// file buffer.cpp
//   copyright  nakazato@phy.cam.ac.uk
//    1st Feb. 2003
//   26th June 2003

#include "buffer.h"

buffer::buffer()
{
    F    = false;
    Ptr  = 0;

    NF   = false;
    N    = 0;
    P[N] = Ptr;
}

buffer::~buffer()
{
}

// cyclic buffer
// old data will be lost
void buffer::Put(char *s)
{
    if (s[0] == 0) return;
    int i = 0;
    while (s[i]) {
        table[Ptr++] = s[i++];
        if (Ptr == MAXC) {
            Ptr = 0;
            F   = true;
        }
    }
    N++;
    if (N == MAXN) {
        N = 0;
        NF = true;
    }
    P[N] = Ptr;
}

// get no-th previouse stored data
// return true if data is obtained 
bool buffer::Get(int no, char *s)
{
    int i, j;

    s[0] = 0;
    if (no < 0) return false;
    no = N - no - 1;
    if (no < 0) 
        if (NF) {
            no += MAXN;
            if (no < N) return false;
        } else return false;
    int ptrS = P[no];
    no++;
    if (no == MAXN) no = 0;
    int ptrE = P[no];
    if ( (ptrS < ptrE) && ( (ptrE <= Ptr) || ( (F) && (Ptr <= ptrS) ) ) ) {
        for(j = 0, i = ptrS; i < ptrE; )
            s[j++] = table[i++];
        s[j] = 0;
        return true;
    } else if ( (F) && (ptrE <= Ptr) && (Ptr <= ptrS) ) {
        for(j = 0, i = ptrS; i < MAXC; ) s[j++] = table[i++];
        for(i = 0; i < ptrE; ) s[j++] = table[i++];
        s[j] = 0;
        return true;
    } else return false;
}
