// file calc.h
//   copyright  nakazato@phy.cam.ac.uk
//   1st Feb. 2003
//       first version
//   8th Feb. 2003
//       more error messages
//   15th Feb. 2003
//       'list' is added
//   23rd Feb. 2003
//       'clear' is added
//       'delTable' is added

//* reserved commands *
#define now          24  //number of pre-defined words
#define al           64  //muximum string length of one word

//* table *
#define txmax       100  //table size
#define tmax        800  //table name buffer size

//* function *
#define index_max      8  //max number of function suffix
#define index_maxc 16384  //function buffer size

//
#define _FINDEX  1
#define _ASSIGN  2

class calc
{
public:
    calc();
    ~calc();
    void clear();
    int read_table(char *name[], int *index);
    void delTable(int i);
    void list(char *list, int maxchar=2048);
    int result(char *text, double *x, char *result, char *format = "%g");
    void set_ang(int i = 0);
    void sprintfn(char *s, char *f, double x);

private:
    int  ang;               // 0:rad 1:deg

    // input
    struct input {
        char    *text;    // text
        char    ch;       // character
        int     p;        // pointer
        int     prevp;    // previouse pointer
        int     sym;      // symbol
        char    id[al];   // id name
        double  num;      // number
    };

    struct vfuncstr {
        int  n;
        int  ptr[index_max];
        int  exptr;
    } ;

    struct vtable {
        char    table[tmax];
        int     tx;
        int     lastt;
        int     namptr[txmax];
        double  value[txmax];
        char    flag[txmax];
        vfuncstr funcstr[txmax];
        int  exbufptr;
        char exbuf[index_maxc];
    } v;

    struct {
        int  n;
        int  ptr[index_max];
    } wfuncstr[txmax];

    struct work {
        int ptr;
        bool SyntaxC;
        int error_no;
    } ;

    void error_(input *t, work *w, int i);
    int condense(char *s, int i);
    void getch(input *t);
    int isdigitb(char c, int base);
    double constant(input *t);
    void getsym(input *t);
    int  lookup(char *name, vtable *vtable);
    void instal(char *name, input *t, vtable *vtable, work *w);
    int  position(char *id, input *t, vtable *vtable, work *w);
    double getarg(input *t, vtable *v, work *w);
    double fgetarg(input *t, vtable *v, work *w);
    double AngArg(double x);
    double _AngArg(double x);
    double value(input *t, vtable *v, work *w);
    double _not(input *t, vtable *v, work *w);
    double power(input *t, vtable *v, work *w);
    double multidiv(input *t, vtable *v, work *w);
    double addsub(input *t, vtable *v, work *w);
    double equal(input *t, vtable *v, work *w);
    double gtrlss(input *t, vtable *v, work *w);
    double _and(input *t, vtable *v, work *w);
    double _or(input *t, vtable *v, work *w);
    double ifthenelse(input *t, vtable *v, work *w);
    double let(input *t, vtable *v, work *w);
    double expr(input *t, vtable *v, work *w);
    void nconvert(char *s, double x, int n, int m);
};
