/****************************************************************************
file: getFileNameDiag.h
  copyright nakazato@phy.cam.ac.uk
  23rd July 2003
****************************************************************************/
#include "getFileNameDiag.h"

#include <qtextbrowser.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qfileinfo.h>

#define ext ".slc"

extern bool QVGA;

getFileNameDiag::getFileNameDiag( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "getFileNameDiag" );
    if (QVGA)
        resize( 220, 200 );
    else
        resize( 350, 340 );

#include "pal2"

    setPalette( pal );
    setCaption( tr( "File Name" ) );

    PushButtonOK = new QPushButton( this, "PushButtonOK" );
    PushButtonCancel = new QPushButton( this, "PushButtonCancel" );
    TextLabelDir = new QLabel( this, "TextLabelDir");
    ListBox1 = new getFileNameDiagListBox( this, "ListBox1" );
    if (QVGA) {
        PushButtonOK->setGeometry( QRect(105, 2, 50, 18 ) );
        PushButtonCancel->setGeometry( QRect(160, 2, 50, 18 ) );
        TextLabelDir->setGeometry( QRect( 10, 20, 200, 15 ) );
        ListBox1->setGeometry( QRect( 10, 35, 200, 150 ) );
    } else {
        PushButtonOK->setGeometry( QRect(175, 2, 80, 27 ) );
        PushButtonCancel->setGeometry( QRect(260, 2, 80, 27 ) );
        TextLabelDir->setGeometry( QRect( 10, 30, 330, 20 ) );
        ListBox1->setGeometry( QRect( 10, 55, 330, 280 ) );
    }
    PushButtonOK->setText( tr ( "OK" ) );
    PushButtonCancel->setText( tr ( "Cancel" ) );

    connect(ListBox1, SIGNAL(clicked(QListBoxItem*)), this, SLOT(selection(QListBoxItem*)) );
    connect(ListBox1, SIGNAL(  upD()), this, SLOT(  upDselection()) );
    connect(ListBox1, SIGNAL(downD()), this, SLOT(downDselection()) );

    fdir.setFilter( QDir::All );
    fdir.setSorting( QDir::DirsFirst);
}

getFileNameDiag::~getFileNameDiag()
{
}

void getFileNameDiag::selection(QListBoxItem* item)
{
    if (item) {
        QString FileName = item->text();
        if (FileName == "..")
            upDselection();
        else if (FileName.contains("/", false) == 1)
            dir(DirName+"/"+FileName);
    }
}

void getFileNameDiag::upDselection()
{
    fdir.cdUp();
    dir(fdir.absPath());
}

void getFileNameDiag::downDselection()
{
    dir(DirName+"/"+ListBox1->currentText());
}

void getFileNameDiag::dir(QString Dir)
{
    fdir.cd(Dir);
    DirName = fdir.absPath();
    TextLabelDir->setText(DirName);

    const QFileInfoList *list = fdir.entryInfoList();
    QFileInfoListIterator it( *list );
    QFileInfo *fi;

    ListBox1->clear();
    while ( (fi=it.current()) ) {
        QString s = fi->fileName();
        if (s == "..") ListBox1->insertItem(s, -1);
        else if (s != ".") { 
            if (fi->isDir()){
                s = s + "/";
                ListBox1->insertItem(s, -1);
            } else if (s.contains(ext, false) == 1)
                ListBox1->insertItem(s, -1);
        }
        ++it;
    }
    ListBox1->setCurrentItem ( ListBox1->firstItem () );
    ListBox1->setFocus();
}
