/****************************************************************************
file: getFileNameDiag.h
  copyright nakazato@phy.cam.ac.uk
  23rd July 2003
****************************************************************************/
#ifndef GETFILENAMEDIAG_H
#define GETFILENAMEDIAG_H

#define MAXFILE 1024

#include <qvariant.h>
#include <qwidget.h>
#include <qlistbox.h>
#include <qdir.h>
#include <qlabel.h>
#include <qpushbutton.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout;
class QListBoxItem;
class QKeyEvent;

class getFileNameDiagListBox : public QListBox
{
    Q_OBJECT
	    
public:
    getFileNameDiagListBox(QWidget* parent = 0, const char* name = 0)
        : QListBox(parent, name){ }
    ~getFileNameDiagListBox() { }

protected:
    void keyPressEvent(QKeyEvent *key)
    {
        if ( (key->key() == Key_F33)||
             (key->key() == Key_Return) ) {
            QString s = currentText();
            if (s=="..")
                emit upD();
            else if (s.contains("/", false) == 1)
                emit downD();
            else
                emit OK();
        } else if ( (key->key() == Key_Escape)||
                    (key->key() == Key_F11   )  )
            emit Cancel();
        else
            QListBox::keyPressEvent(key);
    }

signals:
    void upD();
    void downD();
    void OK();
    void Cancel();
};

class getFileNameDiag : public QWidget
{ 
    Q_OBJECT

public:
    getFileNameDiag( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~getFileNameDiag();

    getFileNameDiagListBox* ListBox1;

    QString DirName;
    QDir fdir;
    QLabel* TextLabelDir;
    QPushButton* PushButtonOK;
    QPushButton* PushButtonCancel;

    void dir(QString DirName);

private slots:
    void selection(QListBoxItem*);
    void upDselection();
    void downDselection();
};

#endif // GETFILENAMEDIAG_H
